<template>
  <section class="banner" ref="banner">
    <h2 class="section__title hidden">Web Goer</h2>
    <Logo ref="logo" />
    <p class="banner__footer-text">
      разработка мобильных<br />приложений и сайтов
    </p>
  </section>
</template>

<script>
import Logo from './Logo'
import { gsap } from 'gsap'
import { ref, onMounted, reactive } from 'vue'

export default {
  name: 'Banner',
  components: {
    Logo
  },
  setup() {
    const mouse = reactive({ x: 0, y: 0, moved: false })
    const logo = ref(null),
      logoParams = ref(null),
      banner = ref(null)

    const parallaxItem = (el, movement, s) => {
      const l = logoParams.value
      gsap.core.Tween.to(el, s, {
        x: ((mouse.x - l.width / 2) / l.width) * movement,
        y: ((mouse.y - l.height / 2) / l.height) * movement
      })
    }

    const callParallax = () => {
      parallaxItem('.move-item.one', -20, 2)
      parallaxItem('.move-item.two', 20, 2)
      parallaxItem('.move-item.three', -20, 2)
    }

    // handler
    const mouseMoveHandler = e => {
      const l = logoParams.value
      mouse.moved = true
      mouse.x = e.clientX - l.left
      mouse.y = e.clientY - l.top
      if (mouse.moved) {
        callParallax()
      }
      mouse.moved = false
    }

    onMounted(() => {
      // get logo coordinates
      logoParams.value = logo.value.$el.getBoundingClientRect()
      banner.value.addEventListener('mousemove', mouseMoveHandler)
    })

    return { logo, banner, mouseMoveHandler }
  }
}
</script>
